---
title: Composer Plugin Drupal Development Environment
repo: https://gitlab.lakedrops.com/composer/plugin/drupal-development-environment
issues: https://gitlab.lakedrops.com/composer/plugin/drupal-development-environment/-/issues
tags:
- composer
- testing
---
# Drupal Development Environment

In addition to the [Drupal Environment](../drupal-environment/index.md), this tool can be installed when
developing Drupal modules, themes or styling pages. 
This composer plugin builds all necessary infrastructure for a Drupal project to make development very handy. To get more
information about tools, see [L3D and Drupal Projects](../../../docker/l3d/drupal.md#introduction-and-overview).

## Testing

It provides a massive amount of testing tools, which can be executed out of the box using 
[Ahoy](../../plugin/ahoy/index.md). To get an overview, just execute:

```l3d
a test --help
```

This will print out a list with all available tools:

- [Dependency Analysis](../../../dev_tools/test.md#drupal-dependency-analysis)
- [PHP Unit](../../../dev_tools/test.md#unitkernelfunctional-testing)
- [PHP Code Sniffer](../../../dev_tools/test.md#php-code-sniffer)
- [PHPStan](../../../dev_tools/test.md#phpstan)
- [PHP Lint](../../../dev_tools/test.md#php-lint)
- [PHP LOC](../../../dev_tools/test.md#php-loc)
- [PHP Mess Detector](../../../dev_tools/test.md#php-mess-detector)
- [PHP Metrics](../../../dev_tools/test.md#php-metrics)
- [Stylelint](../../../dev_tools/test.md#stylelint)
- [Eslint](../../../dev_tools/test.md#es-lint)
- [Cspell](../../../dev_tools/test.md#cspell)

## Working with Themes

The development plugin provides tools, that are common for working with themes in Drupal:

- [Node.js](https://nodejs.org/)
- [Gulp.js](https://gulpjs.com/)

Now you can create or use existing `package.json` or `gulp.js` files for building your `css`, e.g.
using [Sass](https://sass-lang.com/). See more information [here](../../../docker/node/gulp-sass.md).

